Unit PlayM4; 
 
interface
 
uses Windows, SysUtils, Classes; 

  //Max channel numbers
  const PLAYM4_MAX_SUPPORTS = 500;

  //Wave coef range;
  const MIN_WAVE_COEF = -100;
  const MAX_WAVE_COEF = 100;

  //Timer type
  const TIMER_1 = 1; //Only 16 timers for every process.Default TIMER;
  const TIMER_2 = 2; //Not limit;But the precision less than TIMER_1;

  //BUFFER TYPE
  const BUF_VIDEO_SRC = 1;
  const BUF_AUDIO_SRC = 2;
  const BUF_VIDEO_RENDER = 3;
  const BUF_AUDIO_RENDER = 4;

  //Error code
  const  PLAYM4_NOERROR					       = 0;	  //no error
  const	 PLAYM4_PARA_OVER				       = 1;	  //input parameter is invalid;
  const  PLAYM4_ORDER_ERROR				     = 2;	  //The order of the function to be called is error.
  const	 PLAYM4_TIMER_ERROR				     = 3;	  //Create multimedia clock failed;
  const  PLAYM4_DEC_VIDEO_ERROR			   = 4;	  //Decode video data failed.
  const  PLAYM4_DEC_AUDIO_ERROR		     = 5;	  //Decode audio data failed.
  const	 PLAYM4_ALLOC_MEMORY_ERROR	   = 6;	  //Allocate memory failed.
  const  PLAYM4_OPEN_FILE_ERROR			   = 7;	  //Open the file failed.
  const  PLAYM4_CREATE_OBJ_ERROR		   = 8;	  //Create thread or event failed
  const  PLAYM4_CREATE_DDRAW_ERROR		 = 9;	  //Create DirectDraw object failed.
  const  PLAYM4_CREATE_OFFSCREEN_ERROR = 10;	//failed when creating off-screen surface.
  const  PLAYM4_BUF_OVER			         = 11;	//buffer is overflow
  const  PLAYM4_CREATE_SOUND_ERROR	   = 12;	//failed when creating audio device.
  const	 PLAYM4_SET_VOLUME_ERROR	     = 13;	//Set volume failed
  const  PLAYM4_SUPPORT_FILE_ONLY	     = 14;	//The function only support play file.
  const  PLAYM4_SUPPORT_STREAM_ONLY	   = 15;	//The function only support play stream.
  const  PLAYM4_SYS_NOT_SUPPORT		     = 16;	//System not support.
  const  PLAYM4_FILEHEADER_UNKNOWN     = 17;	//No file header.
  const  PLAYM4_VERSION_INCORRECT	     = 18;	//The version of decoder and encoder is not adapted.
  const  PLAYM4_INIT_DECODER_ERROR     = 19;	//Initialize decoder failed.
  const  PLAYM4_CHECK_FILE_ERROR	     = 20;	//The file data is unknown.
  const  PLAYM4_INIT_TIMER_ERROR	     = 21;	//Initialize multimedia clock failed.
  const	 PLAYM4_BLT_ERROR			         = 22;	//Blt failed.
  const  PLAYM4_UPDATE_ERROR		       = 23;	//Update failed.
  const  PLAYM4_OPEN_FILE_ERROR_MULTI  = 24;  //openfile error, streamtype is multi
  const  PLAYM4_OPEN_FILE_ERROR_VIDEO  = 25;  //openfile error, streamtype is video
  const  PLAYM4_JPEG_COMPRESS_ERROR    = 26;  //JPEG compress error
  const  PLAYM4_EXTRACT_NOT_SUPPORT    = 27;	//Don't support the version of this file.
  const  PLAYM4_EXTRACT_DATA_ERROR     = 28;	//extract video data failed.
  const  PLAYM4_SECRET_KEY_ERROR       = 29;	//Secret key is error //add 20071218
  const  PLAYM4_DECODE_KEYFRAME_ERROR  = 30;  //add by hy 200903018

  const  PLAYM4_FAIL_UNKNOWN		       = 99;  //Fail, but the reason is unknown;

  //Max display regions.
  const MAX_DISPLAY_WND = 4;

  //Display type
  const DISPLAY_NORMAL  = 1;
  const DISPLAY_QUARTER = 2;

  //Display buffers
  const MAX_DIS_FRAMES = 50;
  const MIN_DIS_FRAMES = 1;

  //Locate by
  const BY_FRAMENUM  = 1;
  const BY_FRAMETIME = 2;

  //Source buffer
  const SOURCE_BUF_MAX = 1024*100000;
  const SOURCE_BUF_MIN = 1024*50;

  //Stream type
  const STREAME_REALTIME = 0;
  const STREAME_FILE	   = 1;

  //frame type
  const T_AUDIO16 =	101;
  const T_AUDIO8  =	100;
  const T_UYVY	  =	1;
  const T_YV12	  =	3;
  const T_RGB32		= 7;

  //capability
  const SUPPORT_DDRAW		    = 1;
  const SUPPORT_BLT         = 2;
  const SUPPORT_BLTFOURCC   = 4;
  const SUPPORT_BLTSHRINKX  = 8;
  const SUPPORT_BLTSHRINKY  = 16;
  const SUPPORT_BLTSTRETCHX = 32;
  const SUPPORT_BLTSTRETCHY = 64;
  const SUPPORT_SSE         = 128;
  const SUPPORT_MMX			    = 256;

  // HIK_MEDIAINFO
  const FOURCC_HKMI		      =	$484B4D49;	// "HKMI" HIK_MEDIAINFO

  // ----
  const SYSTEM_NULL		      =	$0;				// ûϵͳ㣬ƵƵ
  const SYSTEM_HIK          = $1;				// ļ
  const SYSTEM_MPEG2_PS     = $2;				// PSװ
  const SYSTEM_MPEG2_TS     = $3;				// TSװ
  const SYSTEM_RTP          = $4;				// rtpװ
  const SYSTEM_RTPHIK       = $401;			// rtpװ

  // ----
  const VIDEO_NULL          = $0;				// ûƵ
  const VIDEO_H264          = $1;				// ׼H.264ͺH.264
  const VIDEO_MPEG4         = $3;				// ׼MPEG4
  const VIDEO_AVC264        = $0100;

  // ----
  const AUDIO_NULL          = $0000; // ûƵ
  const AUDIO_ADPCM         = $1000; // ADPCM
  const AUDIO_MPEG          = $2000; // MPEG ϵƵӦMPEGƵ

  // ----
  const AUDIO_G711_U	  =	$7110;
  const AUDIO_G711_A	  =	$7111;
  const AUDIO_G722_1	  =	$7221;
  const AUDIO_G723_1    = $7231;
  const AUDIO_G726      = $7260;
  const AUDIO_G729      = $7290;

TYPE

  //Frame position
  PFRAME_POS = ^TFRAME_POS;

  TFRAME_POS = record
  	nFilePos: integer;
  	nFrameNum: integer;
  	nFrameTime: integer;
  	nErrorFrameNum: integer;
  	pErrorTime: ^SYSTEMTIME;
	  nErrorLostFrameNum: integer;
  	nErrorFrameSize: integer;
  end;


  //Frame Info
  PFRAME_INFO = ^TFRAME_INFO;

  TFRAME_INFO = record
  	nWidth: integer;
  	nHeight: integer;
  	nStamp: integer;
  	nType: integer;
  	nFrameRate: integer;
    dwFrameNum: Cardinal;
  end;

  //Frame
  TFRAME_TYPE = record
  	pDataBuf: PAnsiChar;
  	nSize: integer;
  	nFrameNum: integer;
  	bIsAudio: Boolean;
  	nReserved: integer;
  end;

  //Watermark Info	//add by gb 080119
  TWATERMARK_INFO = record
	  pDataBuf: PAnsiChar;
  	nSize: integer;
  	nFrameNum: integer;
  	bRsaRight: Boolean;
	  nReserved: integer;
  end;

type
    _HIK_MEDIAINFO_ = record
      media_fourcc: Longint;
      media_version: Word;
      device_id: Word;
      system_format: Word;
      video_format: Word;
      audio_format: Word;
      audio_channels: Byte;   //
      audio_bits_per_sample: Byte; //
      audio_samplesrate: Longint;
      audio_bitrate: Longint;
      reserved: Array[0..3] of Longint;
    end {_HIK_MEDIAINFO_};

    HIK_MEDIAINFO = _HIK_MEDIAINFO_;

//////////////////////////////////////////////////////////////////////////////
//API
//////////////////////////////////////////////////////////////////////////////

  ////////////////ver 1.0///////////////////////////////////////
  //Initialize DirecDraw.Now invalid.
  TPlayM4_InitDDraw = function(hWnd: HWND): boolean; stdcall;
  //Release directDraw; Now invalid.
  TPlayM4_RealeseDDraw = function(): boolean; stdcall;

  TPlayM4_OpenFile         = function(nPort: integer; sFileName: PAnsiChar): boolean; stdcall;
  TPlayM4_CloseFile        = function(nPort: integer): boolean; stdcall;
  TPlayM4_Play             = function(nPort: integer; hWnd: HWND): boolean; stdcall;
  TPlayM4_Stop             = function(nPort: integer): boolean; stdcall;
  TPlayM4_Pause            = function(nPort: integer; nPause: Cardinal ): boolean; stdcall;
  TPlayM4_Fast             = function(nPort: integer): boolean; stdcall;
  TPlayM4_Slow             = function(nPort: integer): boolean; stdcall;
  TPlayM4_OneByOne         = function(nPort: integer): boolean; stdcall;
  TPlayM4_SetPlayPos       = function(nPort: integer; fRelativePos: single): boolean;
  TPlayM4_GetPlayPos       = function(nPort: integer): single; stdcall;
  TPlayM4_SetFileEndMsg    = function(nPort: integer; hWnd: HWND; nMsg: UINT): boolean; stdcall;
  TPlayM4_SetVolume        = function(nPort: integer; nVolume: WORD): boolean; stdcall;
  TPlayM4_StopSound        = function(): boolean; stdcall;
  TPlayM4_PlaySound        = function(nPort: integer): boolean; stdcall;
  TPlayM4_OpenStream       = function(nPort: integer; pFileHeadBuf: PBYTE; nSize: Cardinal; nBufPoolSize: Cardinal): boolean; stdcall;
  TPlayM4_InputData        = function(nPort: integer; pBuf: PBYTE; nSize: Cardinal): boolean; stdcall;
  TPlayM4_CloseStream      = function(nPort: integer): boolean; stdcall;
  TPlayM4_GetCaps          = function(): integer; stdcall;
  TPlayM4_GetFileTime      = function(nPort: integer): Cardinal; stdcall;
  TPlayM4_GetPlayedTime    = function(nPort: integer): Cardinal; stdcall;
  TPlayM4_GetPlayedFrames  = function(nPort: integer): Cardinal; stdcall;

  ////////////////ver 2.0 added///////////////////////////////////////

     TDecCBFun     = procedure(nPort: integer; pBuf: PAnsiChar; nSize: integer; FrameInfo: PFRAME_INFO; nReserved1, nReserved2: integer); stdcall;
     TDisplayCBFun = procedure(nPort: integer; pBuf: PAnsiChar; nSize, nWidth, nHeight, nStamp, nType, nReserved: integer); stdcall;

  TPlayM4_SetDecCallBack      = function(nPort: integer; CALLBACK: TDecCBFun): boolean; stdcall;
  TPlayM4_SetDisplayCallBack  = function(nPort: integer; CALLBACK: TDisplayCBFun): boolean; stdcall;

  TPlayM4_ConvertToBmpFile    = function(pBuf: PAnsiChar; nSize, nWidth, nHeight, nType: integer;sFileName: PAnsiChar): boolean; stdcall;

  TPlayM4_GetFileTotalFrames  = function(nPort: integer): Cardinal; stdcall;
  TPlayM4_GetCurrentFrameRate = function(nPort: integer): Cardinal; stdcall;
  TPlayM4_GetPlayedTimeEx     = function(nPort: integer): Cardinal; stdcall;
  TPlayM4_SetPlayedTimeEx     = function(nPort: integer; nTime: Cardinal): boolean; stdcall;
  TPlayM4_GetCurrentFrameNum  = function(nPort: integer): Cardinal; stdcall;
  TPlayM4_SetStreamOpenMode   = function(nPort: integer; nMode: Cardinal): boolean; stdcall;
  TPlayM4_GetFileHeadLength   = function(): Cardinal; stdcall;
  TPlayM4_GetSdkVersion       = function(): Cardinal; stdcall;

  ////////////////ver 2.2 added///////////////////////////////////////
  TPlayM4_GetLastError        = function(nPort: integer): Cardinal; stdcall;
  TPlayM4_RefreshPlay         = function(nPort: integer): boolean; stdcall;
  TPlayM4_SetOverlayMode      = function(nPort: integer; bOverlay: boolean; colorKey: COLORREF): boolean; stdcall;
  TPlayM4_GetPictureSize      = function(nPort: integer; var pWidth, pHeight: integer): boolean; stdcall;
  TPlayM4_SetPicQuality       = function(nPort: integer; bHighQuality: boolean): boolean; stdcall;
  TPlayM4_PlaySoundShare      = function(nPort: integer): boolean; stdcall;
  TPlayM4_StopSoundShare      = function(nPort: integer): boolean; stdcall;

  ////////////////ver 2.4 added///////////////////////////////////////

    TSourceBufCallBack  = procedure(nPort: integer; nBufSize, dwUser: cardinal; pResvered: pointer{--??-void-??--}); stdcall;
    TpFileRefDone       = procedure(nPort, nUser: cardinal); stdcall;

  TPlayM4_GetStreamOpenMode       = function(nPort: integer): integer; stdcall;
  TPlayM4_GetOverlayMode          = function(nPort: integer): integer; stdcall;
  TPlayM4_GetColorKey             = function(nPort: integer): COLORREF; stdcall;
  TPlayM4_GetVolume               = function(nPort: integer): word; stdcall;
  TPlayM4_GetPictureQuality       = function(nPort: integer; var bHighQuality: boolean): boolean; stdcall;
  TPlayM4_GetSourceBufferRemain   = function(nPort: integer): Cardinal; stdcall;
  TPlayM4_ResetSourceBuffer       = function(nPort: integer): boolean; stdcall;
  TPlayM4_SetSourceBufCallBack    = function(nPort: integer; nThreShold: cardinal; CALLBACK: TSourceBufCallBack; dwUser: cardinal; pReserved: pointer{--??-void-??--}): boolean; stdcall;
  TPlayM4_ResetSourceBufFlag      = function(nPort: integer): boolean; stdcall;
  TPlayM4_SetDisplayBuf           = function(nPort: integer; nNum: cardinal): boolean; stdcall;
  TPlayM4_GetDisplayBuf           = function(nPort: integer): Cardinal; stdcall;
  TPlayM4_OneByOneBack            = function(nPort: integer): boolean; stdcall;
  TPlayM4_SetFileRefCallBack      = function(nPort: integer; CALLBACK: TpFileRefDone; nUser: Cardinal): boolean; stdcall;
  TPlayM4_SetCurrentFrameNum      = function(nPort: integer; nFrameNum: cardinal): boolean; stdcall;
  TPlayM4_GetKeyFramePos          = function(nPort: integer; nValue, nType: cardinal; FramePos: PFRAME_POS): boolean; stdcall;
  TPlayM4_GetNextKeyFramePos      = function(nPort: integer; nValue, nType: cardinal; FramePos: PFRAME_POS): boolean; stdcall;

  TPlayM4_InitDDrawDevice         = function(): boolean; stdcall;
  TPlayM4_ReleaseDDrawDevice      = procedure(); stdcall;
  TPlayM4_GetDDrawDeviceTotalNums = function(): Cardinal; stdcall;
  TPlayM4_SetDDrawDevice          = function(nPort: integer; nDeviceNum: cardinal): boolean; stdcall;
  TPlayM4_GetDDrawDeviceInfo      = function(nDeviceNum: cardinal; lpDriverDescription: pAnsiChar; nDespLen: cardinal; lpDriverName: pAnsiChar; nNameLen: cardinal; var hhMonitor: HWND): boolean; stdcall;
  TPlayM4_GetCapsEx               = function(nDDrawDeviceNum: cardinal): integer; stdcall;

  TPlayM4_ThrowBFrameNum          = function(nPort: integer; nNum: cardinal): boolean; stdcall;
  TPlayM4_GetPort                 = function(nPort: PLongint): boolean; stdcall;
  TPlayM4_FreePort                = function(nPort: Longint): boolean; stdcall;
  TPlayM4_GetBMP                  = function(nPort: Longint;pBitmap: pChar; nBufSize: DWORD; pBMPSize: PDWORD): boolean; stdcall;
  TPlayM4_SetTimerType            = function(nPort: Longint;nTimerType: DWORD; nReserved: DWORD): boolean; stdcall;
  TPlayM4_GetJPEG                 = function(nPort: Longint;pJpeg: pChar; nBufSize: DWORD; pJpegSize: PDWORD): boolean; stdcall;

var
  ////////////////ver 1.0///////////////////////////////////////
  PlayM4_OpenFile         :TPlayM4_OpenFile;
  PlayM4_CloseFile        :TPlayM4_CloseFile;
  PlayM4_Play             :TPlayM4_Play;
  PlayM4_Stop             :TPlayM4_Stop;
  PlayM4_Pause            :TPlayM4_Pause;
  PlayM4_Fast             :TPlayM4_Fast;
  PlayM4_Slow             :TPlayM4_Slow;
  PlayM4_OneByOne         :TPlayM4_OneByOne;
  PlayM4_SetPlayPos       :TPlayM4_SetPlayPos;
  PlayM4_GetPlayPos       :TPlayM4_GetPlayPos;
  PlayM4_SetFileEndMsg    :TPlayM4_SetFileEndMsg;
  PlayM4_SetVolume        :TPlayM4_SetVolume;
  PlayM4_StopSound        :TPlayM4_StopSound;
  PlayM4_PlaySound        :TPlayM4_PlaySound;
  PlayM4_OpenStream       :TPlayM4_OpenStream;
  PlayM4_InputData        :TPlayM4_InputData;
  PlayM4_CloseStream      :TPlayM4_CloseStream;
  PlayM4_GetCaps          :TPlayM4_GetCaps;
  PlayM4_GetFileTime      :TPlayM4_GetFileTime;
  PlayM4_GetPlayedTime    :TPlayM4_GetPlayedTime;
  PlayM4_GetPlayedFrames  :TPlayM4_GetPlayedFrames;

  ////////////////ver 2.0 added///////////////////////////////////////
  PlayM4_SetDecCallBack        :TPlayM4_SetDecCallBack;
  PlayM4_SetDisplayCallBack    :TPlayM4_SetDisplayCallBack;

  PlayM4_ConvertToBmpFile      :TPlayM4_ConvertToBmpFile;

  PlayM4_GetFileTotalFrames    :TPlayM4_GetFileTotalFrames;
  PlayM4_GetCurrentFrameRate   :TPlayM4_GetCurrentFrameRate;
  PlayM4_GetPlayedTimeEx       :TPlayM4_GetPlayedTimeEx;
  PlayM4_SetPlayedTimeEx       :TPlayM4_SetPlayedTimeEx;
  PlayM4_GetCurrentFrameNum    :TPlayM4_GetCurrentFrameNum;
  PlayM4_SetStreamOpenMode     :TPlayM4_SetStreamOpenMode;
  PlayM4_GetFileHeadLength     :TPlayM4_GetFileHeadLength;
  PlayM4_GetSdkVersion         :TPlayM4_GetSdkVersion;

  ////////////////ver 2.2 added///////////////////////////////////////
  PlayM4_GetLastError          :TPlayM4_GetLastError;
  PlayM4_RefreshPlay           :TPlayM4_RefreshPlay;
  PlayM4_SetOverlayMode        :TPlayM4_SetOverlayMode;
  PlayM4_GetPictureSize        :TPlayM4_GetPictureSize;
  PlayM4_SetPicQuality         :TPlayM4_SetPicQuality;
  PlayM4_PlaySoundShare        :TPlayM4_PlaySoundShare;
  PlayM4_StopSoundShare        :TPlayM4_StopSoundShare;

  ////////////////ver 2.4 added///////////////////////////////////////
  PlayM4_GetStreamOpenMode          :TPlayM4_GetStreamOpenMode;
  PlayM4_GetOverlayMode             :TPlayM4_GetOverlayMode;
  PlayM4_GetColorKey                :TPlayM4_GetColorKey;
  PlayM4_GetVolume                  :TPlayM4_GetVolume;
  PlayM4_GetPictureQuality          :TPlayM4_GetPictureQuality;
  PlayM4_GetSourceBufferRemain      :TPlayM4_GetSourceBufferRemain;
  PlayM4_ResetSourceBuffer          :TPlayM4_ResetSourceBuffer;
  PlayM4_SetSourceBufCallBack       :TPlayM4_SetSourceBufCallBack;
  PlayM4_ResetSourceBufFlag         :TPlayM4_ResetSourceBufFlag;
  PlayM4_SetDisplayBuf              :TPlayM4_SetDisplayBuf;
  PlayM4_GetDisplayBuf              :TPlayM4_GetDisplayBuf;
  PlayM4_OneByOneBack               :TPlayM4_OneByOneBack;
  PlayM4_SetFileRefCallBack         :TPlayM4_SetFileRefCallBack;
  PlayM4_SetCurrentFrameNum         :TPlayM4_SetCurrentFrameNum;
  PlayM4_GetKeyFramePos             :TPlayM4_GetKeyFramePos;
  PlayM4_GetNextKeyFramePos         :TPlayM4_GetNextKeyFramePos;

  PlayM4_InitDDrawDevice            :TPlayM4_InitDDrawDevice;
  PlayM4_ReleaseDDrawDevice         :TPlayM4_ReleaseDDrawDevice;
  PlayM4_GetDDrawDeviceTotalNums    :TPlayM4_GetDDrawDeviceTotalNums;
  PlayM4_SetDDrawDevice             :TPlayM4_SetDDrawDevice;
  PlayM4_GetDDrawDeviceInfo         :TPlayM4_GetDDrawDeviceInfo;
  PlayM4_GetCapsEx                  :TPlayM4_GetCapsEx;

  PlayM4_ThrowBFrameNum             :TPlayM4_ThrowBFrameNum;
  PlayM4_GetPort                    :TPlayM4_GetPort;
  PlayM4_FreePort                   :TPlayM4_FreePort;
  PlayM4_GetBMP                     :TPlayM4_GetBMP;
  PlayM4_SetTimerType               :TPlayM4_SetTimerType;
  PlayM4_GetJPEG                    :TPlayM4_GetJPEG;






implementation
  Var
      Hd:THandle;

initialization

  Hd:=LoadLibrary('Playctrl.dll');
  if Hd=0 then Exit;

  ////////////////ver 1.0///////////////////////////////////////
  PlayM4_OpenFile         :=GetProcAddress(Hd,'PlayM4_OpenFile');
  PlayM4_CloseFile        :=GetProcAddress(Hd,'PlayM4_CloseFile');
  PlayM4_Play             :=GetProcAddress(Hd,'PlayM4_Play');
  PlayM4_Stop             :=GetProcAddress(Hd,'PlayM4_Stop');
  PlayM4_Pause            :=GetProcAddress(Hd,'PlayM4_Pause');
  PlayM4_Fast             :=GetProcAddress(Hd,'PlayM4_Fast');
  PlayM4_Slow             :=GetProcAddress(Hd,'PlayM4_Slow');
  PlayM4_OneByOne         :=GetProcAddress(Hd,'PlayM4_OneByOne');
  PlayM4_SetPlayPos       :=GetProcAddress(Hd,'PlayM4_SetPlayPos');
  PlayM4_GetPlayPos       :=GetProcAddress(Hd,'PlayM4_GetPlayPos');
  PlayM4_SetFileEndMsg    :=GetProcAddress(Hd,'PlayM4_SetFileEndMsg');
  PlayM4_SetVolume        :=GetProcAddress(Hd,'PlayM4_SetVolume');
  PlayM4_StopSound        :=GetProcAddress(Hd,'PlayM4_StopSound');
  PlayM4_PlaySound        :=GetProcAddress(Hd,'PlayM4_PlaySound');
  PlayM4_OpenStream       :=GetProcAddress(Hd,'PlayM4_OpenStream');
  PlayM4_InputData        :=GetProcAddress(Hd,'PlayM4_InputData');
  PlayM4_CloseStream      :=GetProcAddress(Hd,'PlayM4_CloseStream');
  PlayM4_GetCaps          :=GetProcAddress(Hd,'PlayM4_GetCaps');
  PlayM4_GetFileTime      :=GetProcAddress(Hd,'PlayM4_GetFileTime');
  PlayM4_GetPlayedTime    :=GetProcAddress(Hd,'PlayM4_GetPlayedTime');
  PlayM4_GetPlayedFrames  :=GetProcAddress(Hd,'PlayM4_GetPlayedFrames');

  ////////////////ver 2.0 added///////////////////////////////////////
  PlayM4_SetDecCallBack           :=GetProcAddress(Hd,'PlayM4_SetDecCallBack');
  PlayM4_SetDisplayCallBack       :=GetProcAddress(Hd,'PlayM4_SetDisplayCallBack');

  PlayM4_ConvertToBmpFile         :=GetProcAddress(Hd,'PlayM4_ConvertToBmpFile');

  PlayM4_GetFileTotalFrames       :=GetProcAddress(Hd,'PlayM4_GetFileTotalFrames');
  PlayM4_GetCurrentFrameRate      :=GetProcAddress(Hd,'PlayM4_GetCurrentFrameRate');
  PlayM4_GetPlayedTimeEx          :=GetProcAddress(Hd,'PlayM4_GetPlayedTimeEx');
  PlayM4_SetPlayedTimeEx          :=GetProcAddress(Hd,'PlayM4_SetPlayedTimeEx');
  PlayM4_GetCurrentFrameNum       :=GetProcAddress(Hd,'PlayM4_GetCurrentFrameNum');
  PlayM4_SetStreamOpenMode        :=GetProcAddress(Hd,'PlayM4_SetStreamOpenMode');
  PlayM4_GetFileHeadLength        :=GetProcAddress(Hd,'PlayM4_GetFileHeadLength');
  PlayM4_GetSdkVersion            :=GetProcAddress(Hd,'PlayM4_GetSdkVersion');


  ////////////////ver 2.2 added///////////////////////////////////////
  PlayM4_GetLastError             :=GetProcAddress(Hd,'PlayM4_GetLastError');
  PlayM4_RefreshPlay              :=GetProcAddress(Hd,'PlayM4_RefreshPlay');
  PlayM4_SetOverlayMode           :=GetProcAddress(Hd,'PlayM4_SetOverlayMode');
  PlayM4_GetPictureSize           :=GetProcAddress(Hd,'PlayM4_GetPictureSize');
  PlayM4_SetPicQuality            :=GetProcAddress(Hd,'PlayM4_SetPicQuality');
  PlayM4_PlaySoundShare           :=GetProcAddress(Hd,'PlayM4_PlaySoundShare');
  PlayM4_StopSoundShare           :=GetProcAddress(Hd,'PlayM4_StopSoundShare');

  ////////////////ver 2.4 added///////////////////////////////////////
  PlayM4_GetStreamOpenMode          :=GetProcAddress(Hd,'PlayM4_GetStreamOpenMode');
  PlayM4_GetOverlayMode             :=GetProcAddress(Hd,'PlayM4_GetOverlayMode');
  PlayM4_GetColorKey                :=GetProcAddress(Hd,'PlayM4_GetColorKey');
  PlayM4_GetVolume                  :=GetProcAddress(Hd,'PlayM4_GetVolume');
  PlayM4_GetPictureQuality          :=GetProcAddress(Hd,'PlayM4_GetPictureQuality');
  PlayM4_GetSourceBufferRemain      :=GetProcAddress(Hd,'PlayM4_GetSourceBufferRemain');
  PlayM4_ResetSourceBuffer          :=GetProcAddress(Hd,'PlayM4_ResetSourceBuffer');
  PlayM4_SetSourceBufCallBack       :=GetProcAddress(Hd,'PlayM4_SetSourceBufCallBack');
  PlayM4_ResetSourceBufFlag         :=GetProcAddress(Hd,'PlayM4_ResetSourceBufFlag');
  PlayM4_SetDisplayBuf              :=GetProcAddress(Hd,'PlayM4_SetDisplayBuf');
  PlayM4_GetDisplayBuf              :=GetProcAddress(Hd,'PlayM4_GetDisplayBuf');
  PlayM4_OneByOneBack               :=GetProcAddress(Hd,'PlayM4_OneByOneBack');
  PlayM4_SetFileRefCallBack         :=GetProcAddress(Hd,'PlayM4_SetFileRefCallBack');
  PlayM4_SetCurrentFrameNum         :=GetProcAddress(Hd,'PlayM4_SetCurrentFrameNum');
  PlayM4_GetKeyFramePos             :=GetProcAddress(Hd,'PlayM4_GetKeyFramePos');
  PlayM4_GetNextKeyFramePos         :=GetProcAddress(Hd,'PlayM4_GetNextKeyFramePos');

  PlayM4_InitDDrawDevice            :=GetProcAddress(Hd,'PlayM4_InitDDrawDevice');
  PlayM4_ReleaseDDrawDevice         :=GetProcAddress(Hd,'PlayM4_ReleaseDDrawDevice');
  PlayM4_GetDDrawDeviceTotalNums    :=GetProcAddress(Hd,'PlayM4_GetDDrawDeviceTotalNums');
  PlayM4_SetDDrawDevice             :=GetProcAddress(Hd,'PlayM4_SetDDrawDevice');
  PlayM4_GetDDrawDeviceInfo         :=GetProcAddress(Hd,'PlayM4_GetDDrawDeviceInfo');
  PlayM4_GetCapsEx                  :=GetProcAddress(Hd,'PlayM4_GetCapsEx');

  PlayM4_ThrowBFrameNum             :=GetProcAddress(Hd,'PlayM4_ThrowBFrameNum');

  PlayM4_GetPort                    :=GetProcAddress(Hd,'PlayM4_GetPort');
  PlayM4_FreePort                   :=GetProcAddress(Hd,'PlayM4_FreePort');
  PlayM4_GetBMP                     :=GetProcAddress(Hd,'PlayM4_GetBMP');
  PlayM4_SetTimerType               :=GetProcAddress(Hd,'PlayM4_SetTimerType');
  PlayM4_GetJPEG                    :=GetProcAddress(Hd,'PlayM4_GetJPEG');


Finalization

  if Hd<>0 then FreeLibrary(Hd);

end.
